LeetCode 46 - Permutations

Поделиться
HTML-код
  • Опубликовано: 11 дек 2024

Комментарии • 106

  • @meamail
    @meamail 5 лет назад +86

    This is the best recursive tree explanation I ever seen. Thank you

  • @Chloe-si2hq
    @Chloe-si2hq 2 года назад +7

    Thank you for your patience and hard work for actually walking us through the recursive process. The recursion tree is clear and solid. You really know what you are teaching unlike most of the LeetCode RUclipsr out there who only copy and paste code. Thanks again!

  • @soumikkarmakar7433
    @soumikkarmakar7433 2 года назад +2

    No one cared to explain how recursion is working inside the for loop. But you did it thanks a lot man!!

  • @joseulissescastro4883
    @joseulissescastro4883 Год назад +1

    That was the only video that helped me to really understand what happens in a backtracking solution.
    Thank you sir

  • @ShubhamKumar-sj6dp
    @ShubhamKumar-sj6dp 2 года назад

    this is the best illustration for recursion tree when called under a loop, every video just draw a two way or three way branch from beginning but this was exactly step by step , thnx

  • @raunakagrawal4230
    @raunakagrawal4230 5 лет назад +11

    I cannot thank you more. This is actually an interview question asked by Google. You made it look like very simple with your explanation. Tons of thank you, man!

    • @Niceguy54444
      @Niceguy54444 4 года назад +4

      everything is simple with good approach

  • @grantg8638
    @grantg8638 5 лет назад +6

    This was the first explanation of the Permutations problem I've found that makes sense. Thank you.

  • @tonyz2203
    @tonyz2203 4 года назад +4

    You are actually explaining how to approach this problem unlike most of the leetcode youtuber( they just memorize the code and type it out). Thank you very much.

  • @chamnil8666
    @chamnil8666 4 года назад +4

    This is the best recursive tree video I have seen so far.Thank you so much SIR,now I can eat something,since I got it down.I was struggling to understand it for over a day.Thanks a million.

  • @danishuddin9752
    @danishuddin9752 2 года назад

    Thank andi guru garu, ee logic ardham kaaka oka roju antha chacchi poya!

  • @ujjwaljha845
    @ujjwaljha845 4 года назад +4

    This is one of the best explanation of recursion I have come across, please keep up the good work.

  • @Zoe-fw6kt
    @Zoe-fw6kt 2 года назад

    please start posting new videos, I watched loads of algothrim videos, yours are the ones that make more senses. and easier to understand, Thank you~~~

  • @danxuehuang2099
    @danxuehuang2099 5 лет назад +16

    It's best ever!! Thank you so much for explaining step by step patiently lol. just hit subscribe but saw your latest update was 8 months ago, it would be great if you can keep going, your explanation is straightforward and super easy to understand, thank you!

  • @quochunghoang8833
    @quochunghoang8833 3 года назад

    Wonderful recursive explanation !!! Thank you.

  • @vibhavkushwaha5809
    @vibhavkushwaha5809 3 года назад

    it was a piece of cake for you.
    And now for others too. Holy moly how well you explained, i cant describe it words, it was way to easy for us to understand what's going on.
    Thanks a ton mate. Cheers :)

  • @StyleTrick
    @StyleTrick Год назад

    Great solution and thinking, thanks!

  • @ruixue6955
    @ruixue6955 2 года назад

    1:22 algorithm - 1:29 recursion
    1:54 go through the recursion tree
    2:40
    11:46 code

  • @KarthikParthasarathy
    @KarthikParthasarathy 4 года назад +1

    Time Complexity Infinity is a great concept , great channel and some brilliant work here

  • @xmaxfuture
    @xmaxfuture 4 года назад +2

    dude, u have the best explanation for this question

  • @prafullakh
    @prafullakh 2 года назад +6

    Today marks 3 years since you posted this video. Why have you stopped posting new videos? You are a very good teacher, Sir. You have a divine gift. Recursive thanks to you.
    PLEASE START POSTING NEW VIDEOS.

  • @ansonmelakayil3281
    @ansonmelakayil3281 4 года назад

    way cleaner solution than whats on leetcode rn. good stuff man. thanks

  • @chandrashekar8309
    @chandrashekar8309 4 года назад +1

    This is it! I found the best recursion explanation. Good one 👍

  • @saelkhlouf1695
    @saelkhlouf1695 2 года назад

    Man you are a life saver !

  • @archanamasilamani5115
    @archanamasilamani5115 5 лет назад +1

    One of the best videos on recursion. Thanks!

  • @leohippochin708
    @leohippochin708 3 года назад

    This video is very well done. Good Job. Man!

  • @becktj
    @becktj 3 года назад

    A very good explanation. I had to watch it 5 times though lol. Thank you!

  • @cooldude3010
    @cooldude3010 4 года назад +1

    Your use of filter to remove an element at an index is awesome. I've been using splice() with concat() but filter() is so much more elegant.

    • @mistercorea
      @mistercorea 2 года назад

      splice should be faster than the filter.

  • @legion_29
    @legion_29 4 года назад

    Please add more LeetCode challenges.. your explanations are awesome. Thank you.

  • @justadev____7232
    @justadev____7232 3 года назад

    Beautiful explanation! Been looking for something like this for a while now!!!

  • @allenllewellynkra
    @allenllewellynkra 4 года назад

    Brilliant explaination. Please do more videos

  • @iamkarthikkeyan
    @iamkarthikkeyan 4 года назад

    Thanks for the clear explanation. This is the best explanation.

  • @navderm
    @navderm 2 года назад

    the removal of one element from an array itself is an O(n) complexity. That turns your solution into O(n*n*(n!))

    • @mistercorea
      @mistercorea 2 года назад

      What if you use a splice() function that will be O(1)? can you explain why it is O(n^2 * n!)?

    • @navderm
      @navderm 2 года назад

      @@mistercorea How does splice work internally? How do you say that splice is an O(1) algorithm? Splice itself cannot be O(1) but at the minimum has to be O(n).

  • @TanujDhaundiyal
    @TanujDhaundiyal 4 года назад

    Explained in such an easy manner. Thanks!

  • @leoc.9630
    @leoc.9630 5 лет назад +3

    You said we didn't use extra space in the video, but I think newNums is an extra space in each call. Space complexity will O(n*k) where n is the depth of tree and k is the extra space in each call. Please clarify.

  • @vtserej
    @vtserej 4 года назад

    best explanation so far

  • @rjkal
    @rjkal 2 года назад +2

    Wow! You did a phenomenal job of explaining this in much simpler terms. Thank you so much for making this. Now, I understand this problem way better.
    I have one question though - Isn't the time complexity O(n * n!) from the tree diagram you illustrated? n times we are doing n! right, or can we reduce O(n * n!) to O(n!)?

  • @saumyaranjannayak2101
    @saumyaranjannayak2101 3 года назад

    Awesome !

  • @xinhe3989
    @xinhe3989 5 лет назад

    The great explanation about tree and recursion.

  • @zidane6165
    @zidane6165 2 года назад

    Read the way of solving it using GeeksForGeeks, AlgoExpert, Leetcode prime solution explanation, couple of youtube videos.
    Didn't understand it from any, but you.
    Thank you.

  • @admercs
    @admercs 2 года назад

    Nice explanation!

  • @tusharborole6155
    @tusharborole6155 5 лет назад

    you are best teacher so far

  • @poojakadiyan8790
    @poojakadiyan8790 4 года назад

    very helpful recursion tree visualization

  • @lamaalnajjar1003
    @lamaalnajjar1003 10 месяцев назад

    great explanation !

  • @joelcruz2873
    @joelcruz2873 3 года назад

    Great video!

  • @aniruddhashahapurkar9244
    @aniruddhashahapurkar9244 Год назад

    Best explanation!!

  • @jsjsjs1116
    @jsjsjs1116 3 года назад

    this guy is a god

  • @apratim1919
    @apratim1919 4 года назад

    Beautiful

  • @mauricegoldberg7458
    @mauricegoldberg7458 4 года назад +1

    Finally I get it!! thank you king

  • @oziomaogbe8665
    @oziomaogbe8665 3 года назад

    Love you bro

  • @dhillon6449
    @dhillon6449 2 года назад

    the best

  • @prvizpirizaditweb2324
    @prvizpirizaditweb2324 3 года назад

    I am really curios about what is really going on behind the scenes , for example when for the first time Permumation returns ,the next line set.pop is executed. But what was the next step? did it return back to the previous function call in the callStack( which seems it is) or did it just increased the i in for loop?

  • @cindy__4920
    @cindy__4920 4 года назад

    Thank you for your explanation! It is pretty useful!

  • @doug8171
    @doug8171 3 года назад

    heap’s algorithm is another way I believe.

  • @Paradise-kv7fn
    @Paradise-kv7fn 3 года назад

    we don't need to create a new list every time.
    We can use :-
    def permute(self, nums: List[int]) -> List[List[int]]:
    n = len(nums)
    ans = []
    def rec(path):
    if not len(nums):
    ans.append(path[:])
    return
    for i in nums[::-1]:
    nums.remove(i)
    path.append(i)
    rec(path)
    path.pop()
    nums.append(i)
    rec([])
    return ans

  • @tirthshah8550
    @tirthshah8550 Год назад

    What is the space complexity for this

  • @thajafsal
    @thajafsal 4 года назад +2

    Cracking the code interview book says the time complexity of this algorithm is not n!

    • @reelinvestor
      @reelinvestor 4 года назад

      The book is right, in the video he didn't take into consideration the additional time required to copy into a new array while removing the item.

  • @senthamilsindhu901
    @senthamilsindhu901 4 года назад

    Great explanation. Thanks!

  • @王传玮
    @王传玮 3 года назад

    nice explanation,thanks man.

  • @piyushsharma1638
    @piyushsharma1638 5 лет назад

    Very well explained video, thanks.

  • @jameskanyi7376
    @jameskanyi7376 3 года назад

    Would you mind explaining how this code will work in a stack frame?

  • @akhilkandibanda
    @akhilkandibanda 4 года назад

    dude amazing explanation thanks

  • @roshni962
    @roshni962 3 года назад

    Thanks :)

  • @eltonstalspets45
    @eltonstalspets45 4 года назад

    Hi. I've tried to make sense of this for a long time but I am still confused. Because the base case (the if statement) is checked for before the nums array is filtered, shouldn't there be one more step of the tree for just pushing the array into the answers. In the tree showed in the video, the last step does not meet the base case because nums is not empty when the base case is checked (nums === [3]). Could someone please clarify?

  • @markliu22
    @markliu22 4 года назад +2

    Anyone know the space complexity?
    Thanks in advance!

    • @burntalmonds9598
      @burntalmonds9598 3 года назад

      I believe O(n!) as well because the array containing the answers will have that many elements

    • @AJewFR0
      @AJewFR0 3 года назад

      Its O(n!). The amount of permutations that you make is n!. your array then is n! large.

  • @nutandevjoshi
    @nutandevjoshi 4 года назад

    I had to play 0.75 speed. But so far its okay, will update after I complete video.

  • @slymastera
    @slymastera 4 года назад

    Thank you.

  • @deepakranganathan9644
    @deepakranganathan9644 3 года назад

    Best explanation thanks :)

  • @utkarshkandpal5960
    @utkarshkandpal5960 4 года назад

    IN line 6 why are we doing this : answers.push([...set]) and why not simply this : answers.push(set)? set is an array and we can simply push the array into the answers array ?

  • @alex.perreras
    @alex.perreras 4 года назад +1

    num.filter has O(N) time complexity - your final complexity is even worse than O(N!). Be careful using this at interview!

  • @ponssuarez4513
    @ponssuarez4513 5 лет назад

    Keep on teaching Man!

  • @aaronargottelopez3488
    @aaronargottelopez3488 3 года назад

    Thanks

  • @sandeshrana7225
    @sandeshrana7225 3 года назад

    best one

  • @gurjotsinghsidhu1643
    @gurjotsinghsidhu1643 3 года назад

    Very nice explanation. Can someone show how to do write this in Python?

  • @whiteeye2121movalik
    @whiteeye2121movalik 4 года назад

    is it allowed to add function parameters? not leaving just the "nums" one? I thought you are not allowed to do that....

  • @rakshith3547
    @rakshith3547 5 лет назад

    good explanation

  • @0xSol_Invictus
    @0xSol_Invictus 4 года назад +3

    These things always make sense in hindsight once it's been explained, but do normal people actually come up with these crazy-ass solutions on their own?? Need to figure out what to take away from this conceptually so I actually learn something instead of just being able to do this exact problem if I see it again.

    • @imjeffreylee
      @imjeffreylee 4 года назад +2

      I guess this is how it works. Problem solving is all about reading the pattern, the more problems you solve the faster you can come up with an idea what algorithm you need to apply. You can say that we are memorizing it, but who isn't? That's why "Practice makes perfect" is a thing. I know I probably never gonna use it again when really working, unless I am on an algorithm research team, but this is how the game is played.

    • @allenalex4861
      @allenalex4861 4 года назад +1

      Exactly What I've been thinking.how on Earth do these guys come up with such solutions.😂😂😂

  • @michaelc8876
    @michaelc8876 4 года назад

    I used Java to write this code. But I get something wrong, the result would be [1,2,3] only. What's the problem with my code here? And how to write it correctly in Java?
    public List permute(int[] nums) {
    if (nums == null || nums.length == 0) return new ArrayList();
    List result = new ArrayList();
    List list = new ArrayList();
    for (int num: nums) list.add(num);
    List todo = new ArrayList();
    backtrack(list, todo, result);
    return result;
    }
    private void backtrack(List list, List todo, List result) {
    if (list.size() == 0) {
    result.add(new ArrayList(todo));
    }
    for (int i = 0; i < list.size(); i++) {
    todo.add(list.get(i));
    list.remove(i);
    backtrack(list,todo,result);
    todo.remove(todo.size() - 1);
    }
    }
    Thanks a lot!

  • @ほっしゃん-b8b
    @ほっしゃん-b8b 4 года назад

    genius

  • @Respect_Mah_Authoritah_
    @Respect_Mah_Authoritah_ 4 года назад

    Why do we have to do set.pop()

  • @skkkk3105
    @skkkk3105 4 года назад

    Can u please add java code?

  • @Dan-tg3gs
    @Dan-tg3gs 4 года назад

    Good explanation but im not sure if its the best implementation in code? I've seen this problem solved using 2 functions with different # of parameters, what are the pros and cons of both implementations?

  • @sanskarkaazi3830
    @sanskarkaazi3830 2 года назад

    Can somebody do this with java. ?

  • @sonukapoor1978
    @sonukapoor1978 4 года назад

    Make more videos

  • @anmolcoolsinha
    @anmolcoolsinha 4 года назад

    Can someone give the java version of this?

  • @psettii
    @psettii 4 года назад +1

    Can any one please share code for Java ?

    • @jagrit07
      @jagrit07 4 года назад

      I used general backtracking logic to implement this. I don't know if its similar to what he is implementing as I only watched the logic.
      class Solution {
      List list=new ArrayList();
      public List permute(int[] nums) {
      backtrack(new ArrayList(),nums);
      return list;
      }
      public void backtrack(List curr,int[] nums)
      {
      if(curr.size()==nums.length)
      {
      list.add(new ArrayList(curr));
      }
      for(int i=0;i

    • @sannge7967
      @sannge7967 4 года назад

      @@jagrit07 hey, can you please explain the code by chance?

    • @kmn1794
      @kmn1794 4 года назад

      Why poke yourself in the eyes and into the brain when learning a new concept whilst coding with Java will do it for you.

  • @prakashgatiyala9869
    @prakashgatiyala9869 Год назад

    😇

  • @joshr9703
    @joshr9703 5 лет назад

    thanks m8

  • @MarsTheProgrammer
    @MarsTheProgrammer 4 года назад

    you lost me 3 minutes in lol...

  • @filduss3209
    @filduss3209 Месяц назад

    great explanation!